<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>SSLProtocolSocketFactory xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/package-summary.html">org.apache.commons.httpclient.protocol</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.io.IOException;
<a name="34" href="#34">34</a>  <strong>import</strong> java.net.InetAddress;
<a name="35" href="#35">35</a>  <strong>import</strong> java.net.Socket;
<a name="36" href="#36">36</a>  <strong>import</strong> java.net.UnknownHostException;
<a name="37" href="#37">37</a>  
<a name="38" href="#38">38</a>  <strong>import</strong> javax.net.ssl.SSLSocketFactory;
<a name="39" href="#39">39</a>  
<a name="40" href="#40">40</a>  <strong>import</strong> org.apache.commons.httpclient.ConnectTimeoutException;
<a name="41" href="#41">41</a>  <strong>import</strong> org.apache.commons.httpclient.params.HttpConnectionParams;
<a name="42" href="#42">42</a>  
<a name="43" href="#43">43</a>  <em>/**<em>*</em></em>
<a name="44" href="#44">44</a>  <em> * A SecureProtocolSocketFactory that uses JSSE to create sockets.</em>
<a name="45" href="#45">45</a>  <em> * </em>
<a name="46" href="#46">46</a>  <em> * @author Michael Becke</em>
<a name="47" href="#47">47</a>  <em> * @author &lt;a href="<a href="mailto:mbowler@GargoyleSoftware.com" target="alexandria_uri">mailto:mbowler@GargoyleSoftware.com</a>">Mike Bowler&lt;/a></em>
<a name="48" href="#48">48</a>  <em> * </em>
<a name="49" href="#49">49</a>  <em> * @since 2.0</em>
<a name="50" href="#50">50</a>  <em> */</em>
<a name="51" href="#51">51</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">SSLProtocolSocketFactory</a> implements <a href="../../../../../org/apache/commons/httpclient/protocol/SecureProtocolSocketFactory.html">SecureProtocolSocketFactory</a> {
<a name="52" href="#52">52</a>  
<a name="53" href="#53">53</a>      <em>/**<em>*</em></em>
<a name="54" href="#54">54</a>  <em>     * The factory singleton.</em>
<a name="55" href="#55">55</a>  <em>     */</em>
<a name="56" href="#56">56</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">SSLProtocolSocketFactory</a> factory = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">SSLProtocolSocketFactory</a>();
<a name="57" href="#57">57</a>      
<a name="58" href="#58">58</a>      <em>/**<em>*</em></em>
<a name="59" href="#59">59</a>  <em>     * Gets an singleton instance of the SSLProtocolSocketFactory.</em>
<a name="60" href="#60">60</a>  <em>     * @return a SSLProtocolSocketFactory</em>
<a name="61" href="#61">61</a>  <em>     */</em>
<a name="62" href="#62">62</a>      <strong>static</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">SSLProtocolSocketFactory</a> getSocketFactory() {
<a name="63" href="#63">63</a>          <strong>return</strong> factory;
<a name="64" href="#64">64</a>      }    
<a name="65" href="#65">65</a>      
<a name="66" href="#66">66</a>      <em>/**<em>*</em></em>
<a name="67" href="#67">67</a>  <em>     * Constructor for SSLProtocolSocketFactory.</em>
<a name="68" href="#68">68</a>  <em>     */</em>
<a name="69" href="#69">69</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/protocol/SSLProtocolSocketFactory.html">SSLProtocolSocketFactory</a>() {
<a name="70" href="#70">70</a>          <strong>super</strong>();
<a name="71" href="#71">71</a>      }
<a name="72" href="#72">72</a>  
<a name="73" href="#73">73</a>      <em>/**<em>*</em></em>
<a name="74" href="#74">74</a>  <em>     * @see SecureProtocolSocketFactory#createSocket(java.lang.String,int,java.net.InetAddress,int)</em>
<a name="75" href="#75">75</a>  <em>     */</em>
<a name="76" href="#76">76</a>      <strong>public</strong> Socket createSocket(
<a name="77" href="#77">77</a>          String host,
<a name="78" href="#78">78</a>          <strong>int</strong> port,
<a name="79" href="#79">79</a>          InetAddress clientHost,
<a name="80" href="#80">80</a>          <strong>int</strong> clientPort)
<a name="81" href="#81">81</a>          throws IOException, UnknownHostException {
<a name="82" href="#82">82</a>          <strong>return</strong> SSLSocketFactory.getDefault().createSocket(
<a name="83" href="#83">83</a>              host,
<a name="84" href="#84">84</a>              port,
<a name="85" href="#85">85</a>              clientHost,
<a name="86" href="#86">86</a>              clientPort
<a name="87" href="#87">87</a>          );
<a name="88" href="#88">88</a>      }
<a name="89" href="#89">89</a>  
<a name="90" href="#90">90</a>      <em>/**<em>*</em></em>
<a name="91" href="#91">91</a>  <em>     * Attempts to get a new socket connection to the given host within the given time limit.</em>
<a name="92" href="#92">92</a>  <em>     * &lt;p></em>
<a name="93" href="#93">93</a>  <em>     * This method employs several techniques to circumvent the limitations of older JREs that </em>
<a name="94" href="#94">94</a>  <em>     * do not support connect timeout. When running in JRE 1.4 or above reflection is used to </em>
<a name="95" href="#95">95</a>  <em>     * call Socket#connect(SocketAddress endpoint, int timeout) method. When executing in older </em>
<a name="96" href="#96">96</a>  <em>     * JREs a controller thread is executed. The controller thread attempts to create a new socket</em>
<a name="97" href="#97">97</a>  <em>     * within the given limit of time. If socket constructor does not return until the timeout </em>
<a name="98" href="#98">98</a>  <em>     * expires, the controller terminates and throws an {@link ConnectTimeoutException}</em>
<a name="99" href="#99">99</a>  <em>     * &lt;/p></em>
<a name="100" href="#100">100</a> <em>     *  </em>
<a name="101" href="#101">101</a> <em>     * @param host the host name/IP</em>
<a name="102" href="#102">102</a> <em>     * @param port the port on the host</em>
<a name="103" href="#103">103</a> <em>     * @param localAddress the local host name/IP to bind the socket to</em>
<a name="104" href="#104">104</a> <em>     * @param localPort the port on the local machine</em>
<a name="105" href="#105">105</a> <em>     * @param params {@link HttpConnectionParams Http connection parameters}</em>
<a name="106" href="#106">106</a> <em>     * </em>
<a name="107" href="#107">107</a> <em>     * @return Socket a new socket</em>
<a name="108" href="#108">108</a> <em>     * </em>
<a name="109" href="#109">109</a> <em>     * @throws IOException if an I/O error occurs while creating the socket</em>
<a name="110" href="#110">110</a> <em>     * @throws UnknownHostException if the IP address of the host cannot be</em>
<a name="111" href="#111">111</a> <em>     * determined</em>
<a name="112" href="#112">112</a> <em>     * </em>
<a name="113" href="#113">113</a> <em>     * @since 3.0</em>
<a name="114" href="#114">114</a> <em>     */</em>
<a name="115" href="#115">115</a>     <strong>public</strong> Socket createSocket(
<a name="116" href="#116">116</a>         <strong>final</strong> String host,
<a name="117" href="#117">117</a>         <strong>final</strong> <strong>int</strong> port,
<a name="118" href="#118">118</a>         <strong>final</strong> InetAddress localAddress,
<a name="119" href="#119">119</a>         <strong>final</strong> <strong>int</strong> localPort,
<a name="120" href="#120">120</a>         <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpConnectionParams.html">HttpConnectionParams</a> params
<a name="121" href="#121">121</a>     ) throws IOException, UnknownHostException, <a href="../../../../../org/apache/commons/httpclient/ConnectTimeoutException.html">ConnectTimeoutException</a> {
<a name="122" href="#122">122</a>         <strong>if</strong> (params == <strong>null</strong>) {
<a name="123" href="#123">123</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Parameters may not be null"</span>);
<a name="124" href="#124">124</a>         }
<a name="125" href="#125">125</a>         <strong>int</strong> timeout = params.getConnectionTimeout();
<a name="126" href="#126">126</a>         <strong>if</strong> (timeout == 0) {
<a name="127" href="#127">127</a>             <strong>return</strong> createSocket(host, port, localAddress, localPort);
<a name="128" href="#128">128</a>         } <strong>else</strong> {
<a name="129" href="#129">129</a>             <em class="comment">// To be eventually deprecated when migrated to Java 1.4 or above</em>
<a name="130" href="#130">130</a>             Socket socket = ReflectionSocketFactory.createSocket(
<a name="131" href="#131">131</a>                 <span class="string">"javax.net.ssl.SSLSocketFactory"</span>, host, port, localAddress, localPort, timeout);
<a name="132" href="#132">132</a>             <strong>if</strong> (socket == <strong>null</strong>) {
<a name="133" href="#133">133</a>                 socket = ControllerThreadSocketFactory.createSocket(
<a name="134" href="#134">134</a>                     <strong>this</strong>, host, port, localAddress, localPort, timeout);
<a name="135" href="#135">135</a>             }
<a name="136" href="#136">136</a>             <strong>return</strong> socket;
<a name="137" href="#137">137</a>         }
<a name="138" href="#138">138</a>     }
<a name="139" href="#139">139</a> 
<a name="140" href="#140">140</a>     <em>/**<em>*</em></em>
<a name="141" href="#141">141</a> <em>     * @see SecureProtocolSocketFactory#createSocket(java.lang.String,int)</em>
<a name="142" href="#142">142</a> <em>     */</em>
<a name="143" href="#143">143</a>     <strong>public</strong> Socket createSocket(String host, <strong>int</strong> port)
<a name="144" href="#144">144</a>         throws IOException, UnknownHostException {
<a name="145" href="#145">145</a>         <strong>return</strong> SSLSocketFactory.getDefault().createSocket(
<a name="146" href="#146">146</a>             host,
<a name="147" href="#147">147</a>             port
<a name="148" href="#148">148</a>         );
<a name="149" href="#149">149</a>     }
<a name="150" href="#150">150</a> 
<a name="151" href="#151">151</a>     <em>/**<em>*</em></em>
<a name="152" href="#152">152</a> <em>     * @see SecureProtocolSocketFactory#createSocket(java.net.Socket,java.lang.String,int,boolean)</em>
<a name="153" href="#153">153</a> <em>     */</em>
<a name="154" href="#154">154</a>     <strong>public</strong> Socket createSocket(
<a name="155" href="#155">155</a>         Socket socket,
<a name="156" href="#156">156</a>         String host,
<a name="157" href="#157">157</a>         <strong>int</strong> port,
<a name="158" href="#158">158</a>         <strong>boolean</strong> autoClose)
<a name="159" href="#159">159</a>         throws IOException, UnknownHostException {
<a name="160" href="#160">160</a>         <strong>return</strong> ((SSLSocketFactory) SSLSocketFactory.getDefault()).createSocket(
<a name="161" href="#161">161</a>             socket,
<a name="162" href="#162">162</a>             host,
<a name="163" href="#163">163</a>             port,
<a name="164" href="#164">164</a>             autoClose
<a name="165" href="#165">165</a>         );
<a name="166" href="#166">166</a>     }
<a name="167" href="#167">167</a> 
<a name="168" href="#168">168</a>     <em>/**<em>*</em></em>
<a name="169" href="#169">169</a> <em>     * All instances of SSLProtocolSocketFactory are the same.</em>
<a name="170" href="#170">170</a> <em>     */</em>
<a name="171" href="#171">171</a>     <strong>public</strong> <strong>boolean</strong> equals(Object obj) {
<a name="172" href="#172">172</a>         <strong>return</strong> ((obj != <strong>null</strong>) &amp;&amp; obj.getClass().equals(getClass()));
<a name="173" href="#173">173</a>     }
<a name="174" href="#174">174</a> 
<a name="175" href="#175">175</a>     <em>/**<em>*</em></em>
<a name="176" href="#176">176</a> <em>     * All instances of SSLProtocolSocketFactory have the same hash code.</em>
<a name="177" href="#177">177</a> <em>     */</em>
<a name="178" href="#178">178</a>     <strong>public</strong> <strong>int</strong> hashCode() {
<a name="179" href="#179">179</a>         <strong>return</strong> getClass().hashCode();
<a name="180" href="#180">180</a>     }    
<a name="181" href="#181">181</a>     
<a name="182" href="#182">182</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

